.code
; brute_key_quick, brute_key_slow, brute_key_mmx
;

    db  'r!sc',0
    
brute_key_quick:    ; brute algo for safedisc r2 and r3
    pushad

    call    find_first_key      ; algo by moelch to find a decent starting key.
    mov     eax, [key_begin]
    mov     ebx, [decrypt_key]
    and     ebx, 01h
    or      eax, ebx
    mov     [decrypt_key], eax
    add     dword ptr [key_begin], 01000000h
    
; brute force the decrypt key
wrong_key:
    inc     dword ptr [decrypt_key]
    inc     dword ptr [decrypt_key] ; skip odd numbered keys :) brute twice as fast !
    mov     esi, [decrypt_key]
    sub     esi, [key_begin]
    test    esi, esi
    je      your_fucked_mate
    
    mov     ebp, 20h
    mov     eax, 0c6ef3720h     ; 9E3779B9h shl 5
    mov     edx, dword ptr [brute_key]
    mov     ecx, dword ptr [brute_key+4]
    mov     esi, [decrypt_key]

    call    brutedecryptloop
    
    test    edx,edx
    jne     bruteswapdecrypt
    test    ecx,ecx
    jne     bruteswapdecrypt    ; did brute_key decrypt to NULL's ?

    popad
gotkey:
    mov eax, [decrypt_key]      ; copy 32bit key 4 times, making it 128bit key..
    lea edi, decrypt_key+4
    mov [edi], eax
    mov [edi+4], eax
    mov [edi+8], eax
    ret                         ; if yes, we got the correct key :d

; try bruting the 'encrypted nulls' swapped around
; a b -> b a

bruteswapdecrypt:

    mov     ebp, 20h
    mov     eax, 0c6ef3720h     ; 9E3779B9h shl 5
    mov     edx, dword ptr [brute_key+4]
    mov     ecx, dword ptr [brute_key]
    mov     esi, [decrypt_key]

    call    brutedecryptloop

    test    edx,edx
    jne     wrong_key
    test    ecx,ecx
    jne     wrong_key           ; did brute_key decrypt to NULL's ?

    popad
    jmp gotkey                  ; if yes, we got the correct key :d

brutedecryptloop:
    mov     edi, edx
    shr     edi, 5
    add     edi, esi
    mov     ebx, edx
    shl     ebx, 4
    add     ebx, esi
    xor     edi, ebx
    lea     ebx, dword ptr [eax+edx]
    xor     edi, ebx
    sub     ecx, edi
    mov     edi, ecx
    shr     edi, 05
    add     edi, esi
    mov     ebx, ecx
    shl     ebx, 04
    add     ebx, esi
    xor     edi, ebx
    lea     ebx, dword ptr [eax+ecx]
    xor     edi, ebx
    sub     edx, edi
    sub     eax, 9E3779B9h
    dec     ebp
    jne     brutedecryptloop
    ret

;_________________________________________________________________________________________
find_first_key: ; moelch's (2nd) method to refine the starting key

    pushad

    mov     ebx, dword ptr [memory_ptr]
    mov     edx, dword ptr [import_ptr]
    add     edx, ebx
    sub     ebx, dword ptr [rdata_va_offset]
    sub     edx, 14h

next_iid_2:
    add     edx, 14h
    mov     eax, dword ptr [edx]
    or      eax, dword ptr [edx+0Ch]
    jne     scan4k32
    jmp done

scan4k32:
    mov     esi, dword ptr [edx+0Ch]
    add     esi, ebx
    cmp     dword ptr [esi], 'NREK'
    je      correct_iid_2
    cmp     dword ptr [esi], 'RESU'
    je      correct_iid_2
    cmp     dword ptr [esi], 'nrek'
    je      correct_iid_2
    cmp     dword ptr [esi], 'resu'
    jne     next_iid_2

correct_iid_2:
    mov     esi, dword ptr [edx]
    add     esi, ebx
    mov     edi, dword ptr [esi]
    or      edi, edi
    jne     next_iid_2
    mov     edi, dword ptr [esi + 4]

    xor     edx, edx
    dec     edx
    mov     ecx, edx
    mov     esi, [rdata_rva]
check_min:
    inc     ecx
    cmp     ecx, [rdata_size]
    ja      done
    mov     eax, edi
    lea     ebx, [ecx+esi]
    xor     eax, ebx
    cmp     eax, edx
    jnb     check_min
    mov     edx, eax
    jmp     check_min

done:
    and     edx, -2
    mov     [key_begin], edx
    popad
    ret

;_________________________________________________________________________________________


brute_key_slow: ; brute force for safedisc r0/r1
    lea edi, brute_key2
    lea esi, brute_key
    mov eax, [esi]      ; put a reverse copy of the dwords into brute_key2
    mov ebx, [esi+4]
    mov [edi], ebx
    mov [edi+4], eax
    
; scan for a known icd size / key ..
    mov byte ptr [dont_write_info], 0
    lea esi, keys_we_know   ; key database, icd_size . decrypt_key ... NULL
@@scan4knownsize:
    mov dword ptr [decrypt_key], 0
    lodsd
    test eax,eax            ; check icd size isnt NULL :)
    je final_scan_checksA
    cmp eax, [icd_size]     ; do we have a match with a size in the database?
    je @@next_check         ; yes? jump to next check ;)
    add esi, 4
    jmp @@scan4knownsize    ; nope, continue scanning database
@@next_check:
    lodsd                   ; get the decrypt_key
    mov [decrypt_key], eax
    push esi
    lea edi, brute_temp
    lea esi, brute_key
    mov [too_decrypt_ptr], edi
    movsd
    movsd
    call gotkey                 ; make 32bit key into a pseudo 128bit one
    call safedisc_decryption    ; test decrypt_key on the encrypted dwords from current icd
    pop esi
    cmp dword ptr [brute_temp+4], 0
    jne oops_sorry
    cmp dword ptr [brute_temp], 0   ; did it decrypt to 00000000 ?
    je  we_so_happy                 ; yes? we got the correct key!
    
oops_sorry:     ; nope, try reverse dwords..
    push esi
    lea edi, brute_temp
    lea esi, brute_key2
    mov [too_decrypt_ptr], edi
    movsd
    movsd
    call gotkey
    call safedisc_decryption    ; test decrypt_key on the reversed encrypted dwords
    pop esi
    cmp dword ptr [brute_temp+4], 0
    jne @@scan4knownsize
    cmp dword ptr [brute_temp], 0   ; did the reversed dwords decrypt to 00000000 ?
    jne @@scan4knownsize

we_so_happy:        ; found a key that decrypted our encrypted nulls !
    mov byte ptr [dont_write_info], 1   ; set flag to say dont write database file after decryption
    call    MessageBoxA, 0, offset good_news, offset error, 0
    jmp     gotkey


final_scan_checksA:  ; little cheats for 'you dont know jack 3' & 'warzone 2100'
    cmp dword ptr [brute_key], 753e8df5h
    jne final_scan_checksB
    cmp [icd_size], 0006D000h
    jne brute_slow
    mov [decrypt_key], 29BD8373h
    jmp we_so_happy
final_scan_checksB:
    cmp dword ptr [brute_key], 0000000bh    ; heh, encrypted null's dodgy algo finds
    jne brute_slow
    cmp [icd_size], 0011CA00h               ; icd size of warzone 2100
    jne brute_slow
    mov [decrypt_key], 0CAF6E1AFh           ; decrypt key
    mov edi, dword ptr [de_section_ptr]
    mov dword ptr [edi+4], 0                ; dont decrypt .data
    jmp we_so_happy

brute_slow:
    pushad    
    call    MessageBoxA, 0, offset bad_news, offset error, 0
    call    GetTickCount
    mov     [tick1], eax ; dont fuck with me! :)

    mov     byte ptr [brute_fucked], 1
    
    cmp dword ptr [mmx_cpu], 1
    je init_brute_mmx
;----------------------------------------
; brute force the decrypt key
; almost highly optimised, 4 or 5 less instructions used than in the other brute_algo

wrong_keys:

    inc     dword ptr [decrypt_key]
    js      try_swapping_brutetemp2   ; js, only test keys below 80000000h .. only found two
                                      ; keys above this, for rainbox six(r0) & Imperium Galactica(r?)
    mov     ebp, 20h
    mov     eax, 0c6ef3720h     ; 9E3779B9h shl 5
    mov     edx, dword ptr [brute_key]
    mov     ecx, dword ptr [brute_key+4]
    mov     esi, [decrypt_key]  ; hmm, main key

brutedecryptloops:
    mov     edi, edx    ; mov 1st dword to decrypt into edi
    mov     ebx, edx    ; mov 1st dword to decrypt into ebx
    shr     edi, 5      ; shift edi 5 bits
    shl     ebx, 4      ; shift ebx 4 bits
    add     edi, esi    ; add decrypt_key to it
    add     ebx, esi    ; add decrypt_key to it

    xor     edi, ebx    ; xor results..
    lea     ebx, dword ptr [eax+edx]    ; add 1st dword and numberX
    xor     edi, ebx    ; xor that with last result
    sub     ecx, edi    ; sub result of first maths off 2nd dword to decrypt

    mov     edi, ecx    ; yak
    mov     ebx, ecx    ; yak
    shr     edi, 05     ; yak
    shl     ebx, 04     ; get
    add     edi, esi    ; a
    add     ebx, esi    ; job
    
    xor     edi, ebx
    lea     ebx, dword ptr [eax+ecx]
    xor     edi, ebx
    sub     edx, edi

    sub     eax, 9E3779B9h  ; fuck with numberX

    dec     ebp
    jne     brutedecryptloops

    test    edx,edx
    jne     wrong_keys
    test    ecx,ecx
    jne     wrong_keys
    popad
    jmp gotkey          ; if yes, we got the correct key :d


; the two dword's we got from the data section, the 'encrypted nulls' were in the wrong order..
; a b -> b a . only 1hr or so wasted by this point :)

try_swapping_brutetemp2:
    cmp     byte ptr [brute_fucked], 0
    je      your_fucked_mate
    call    MessageBoxA, 0, offset more_bad_news, offset error, 0
    lea     esi, brute_key
    mov     eax, [esi]      ; swap
    mov     ebx, [esi+4]    ; the
    mov     [esi], ebx      ; dwords
    mov     [esi+4], eax    ; around

    mov     byte ptr [brute_fucked], 0
    mov     dword ptr [decrypt_key], 0
    jmp     wrong_keys

;_________________________________________________________________________________________


; begin of brute force
init_brute_mmx:

    mov     eax, dword ptr [brute_key]
    movd    mm0, eax
    mov     eax, dword ptr [brute_key+4]
    movd    mm1, eax
    punpckldq   mm0, mm0
    punpckldq   mm1, mm1
    movq    [mcipher1], mm0
    movq    [mcipher2], mm1

    mov     dword ptr [decrypt_key], -2
    mov     dword ptr [decrypt_key+4], -1
    
    movq    mm7, qword ptr [mmconst1]
    lea     esi, mmx_esi
    db 9 DUP (90h)          ; align code
                            ; movq    mm0, qword ptr [mmconst2] HAS? to fall on 40xxx6 or 40xxx8
                            ; probably (for an amd k6 anyway :)

; haha, hopefully this is stupidly fast code.
; about 85 seconds faster than previous code at testing 1,446,719,545 key's (amd 450)
brute_key_mmx:
    add dword ptr [decrypt_key], 2
    add dword ptr [decrypt_key+4], 2
    js mm_try_swapping_brutetemp

    mov     edx, 000000020h

; qword pointers MUST be aligned on a 10h byte boundry, erm, i.e xxxx40h, xxxx60h .

    movq    mm0, qword ptr [mmconst2]
    movq    mm4, qword ptr [decrypt_key]    ; mov esi, [decrypt_key]
    movq    mm3, [mcipher1] ; mov edx, [brute_key]
    movq    mm2, [mcipher2] ; mov ecx, [brute_key+4]

mmx_tea_loop:
    movq    mm5, mm3    ; mov edi, edx
    movq    mm1, mm3    ; mov ebx, edx
    psrld   mm5, 5      ; shr edi, 5
    pslld   mm1, 4      ; shl ebx, 4
    nop     ; very important (on an amd k6 :)
    nop     ;  "          "
    paddd   mm5, mm4    ; add edi, esi
    paddd   mm1, mm4    ; add ebx, esi
    
    pxor    mm5, mm1    ; xor edi, ebx
    movq    mm1, mm3    ; lea ebx, [edx
    paddd   mm1, mm0    ; +eax]
    pxor    mm5, mm1    ; xor edi, ebx
    psubd   mm2, mm5    ; sub ecx, edi
    
    movq    mm5, mm2    ; mov edi, ecx
    movq    mm1, mm2    ; mov ebx, ecx
    psrld   mm5, 5      ; shr edi, 5
    pslld   mm1, 4      ; shl ebx, 4
    nop     ; very important (screw pentium's as i dont own one)
    nop     ;  "          "
    paddd   mm5, mm4    ; add edi, esi
    paddd   mm1, mm4    ; add ebx, esi
    
    pxor    mm5, mm1    ; xor edi, ebx
    movq    mm1, mm2    ; lea ebx, [ecx
    paddd   mm1, mm0    ; +eax]
    pxor    mm5, mm1    ; xor edi, ebx
    psubd   mm3, mm5    ; sub edx, edi
    
    psubd   mm0, mm7    ; sub eax, 09e3779b9h
    
    dec     edx
    jnz     mmx_tea_loop

    movq    [esi], mm3  ; mm3 is [brute_key] (encrypted null's)
    cmp dword ptr [esi], 0
    je mm_key_found
    cmp dword ptr [esi+4],0
    jne brute_key_mmx

mm_key_found:
    movq    [esi], mm2  ; mm2 is [brute_key+4] (encrypted null's)
    cmp     dword ptr [esi], 0
    je      mm_key_ok   ; [decrypt_key] decrypted this to 0's
    cmp     dword ptr [esi+4],0
    jne     brute_key_mmx    ; heh, something is wrong.
    mov     esi, [decrypt_key+4]    ; else, dk+4 decrypted it to 0's
    mov     [decrypt_key], esi    
mm_key_ok:
    popad
    jmp gotkey

; the two dword's we got from the data section, the 'encrypted nulls' were in the wrong order..
; a b -> b a . only 1hr or so wasted by this point :)

mm_try_swapping_brutetemp:
    cmp     byte ptr [brute_fucked], 0
    je      your_fucked_mate
    call    MessageBoxA, 0, offset more_bad_news, offset error, 0
    lea     esi, brute_key
    mov     eax, [esi]      ; swap
    mov     ebx, [esi+4]    ; the
    mov     [esi], ebx      ; dwords
    mov     [esi+4], eax    ; around

    mov     byte ptr [brute_fucked], 0
    jmp     init_brute_mmx