.code

re_fix_calls:
    cmp     [dll_size], 172544      ; if dplayerx.dll is 172,544 bytes, calls need fixing
    je      re_fix_ok
    cmp     [dll_size], 173568      ; if dplayerx.dll is 173,568 bytes, calls need fixing
    je      re_fix_ok
    cmp     [dll_size], 136704      ; yak yak yak ;)
    je      re_fix_ok
    cmp     [dll_size], 138752
    je      re_fix_ok
    ret
    
re_fix_ok:    
    mov esi, offset empty   ; empty is the tiny buffer, which contains pointers to each
                            ; decrypted section, or 'sections to decrypt' .. (in the pe header)
    
next_section:
    push esi
    mov esi, [esi]
    or esi, esi
    jne more_stuff_to_fix   ; woo! we have a section thats been decrypted that may need calls fixing
    pop esi
    ret

more_stuff_to_fix:
    mov ebx, [esi+14h]  ; raw offset
    mov edx, [esi+10h]  ; section's RAW size
    mov [re_temp_offset], ebx
    add dword ptr [re_temp_offset], 2
rfc_size_ok:
    mov ecx, dword ptr [esi+14h]       ; section's RAW offset
    add ecx, dword ptr [memory_ptr]    ; ecx points to beginning of section
    mov esi, ecx

    add edx, ebx       ; edx == raw offset+raw size of section
    add ebx, 2
    add ecx, 2
    sub edx, 4

rfc_scan_next_byte:
    inc esi
    mov eax, esi
    sub eax, [memory_ptr]   ; eax raw offset to byte
    cmp eax, edx            ; check its lower than the size of this section
    jl  rfc_check_ff15
rfc_get_next_section:
    pop esi
    add esi, 4          ; prep esi so it points to next decrypted section
    jmp next_section

rfc_check_ff15:
    sub eax, ebx    ; eax == raw offset in section
    add ebx, eax
    add ecx, eax
    cmp word ptr [ecx-02], 15FFh    ; do we have a CALL DWORD PTR ?
    jne rfc_scan_next_byte

; decide whether or not the call needs fixing
    push edx
    push ecx
    mov eax, ebx
    sub eax, dword ptr [re_temp_offset]      ; eax == raw offset relative to section
    add eax, [decrypt_key]  ; <- code @ !text+5468 in dplayerx.dll
    xor edx, edx

; new code

    cmp     [dll_size], 136704
    je      raxs_api_stuff
    cmp     [dll_size], 138752
    jnz     skip_fucking_about

; for safedisc r4 & r5 :)

raxs_api_stuff:
    sub     eax, [decrypt_key]  ; we dont fuck with the decrypt key
    mov     ecx, eax            ; make a copy of the calling address
    mov     edx,[dplay_base_addr]
    cmp     [dll_size], 136704
    jz      add_650eh
    add     edx, 6CEEh          ; the offset to the rotate,add,xor,sub,etc,etc function for r5
    jmp     add_115
add_650eh:
    add     edx, 650eh          ; the offset to teh raxs function in r4
add_115:
    add     edx, 115h
    call    edx                     ; morph it
    xor     eax, ecx                ; xor encrypted, original
    mov     ecx, eax                ; copy encrypted & xor'ed address
    sub     edx, 115h
    call    edx                     ; morph it again
    xor     edx, edx
    xor     eax, ecx                ; xor again
    mov     ecx, 4                  ; then do simple maths
    div     ecx                     ; to see if we should fix
    mov     eax, edx                ; the calling address
    pop     ecx
    pop     edx
    cmp     eax, 2
    jae     rfc_scan_next_byte
    jmp     decide_which_library

skip_fucking_about:
    cmp [dll_size], 173568
    jne re_older_fix
    
; code for newer call fixing (r3.5)
    mov ecx, 4
    div ecx
    cmp edx, 3
    sbb edx,edx
    neg edx
    mov eax, edx
    pop ecx
    pop edx
    cmp eax, 1  ; was remainder of maths '1' ?
    jne rfc_scan_next_byte
    jmp decide_which_library


re_older_fix:   ;) (r3.0)
    mov ecx, 3      ; dplayerx -> 00001560h ... (file offset :)
    div ecx
    mov eax, edx
    pop ecx
    pop edx
    cmp eax, 1  ; was remainder of maths '1' ?
    jne rfc_scan_next_byte


decide_which_library:
; kernel or user api to be fixed?
    mov edi, 08h
    mov eax, [ecx]                  ; ecx -> pointer to api
    sub eax, [pe_image_base]
blubb1:    
    sub edi, 04h
    cmp edi, -04h
    je rfc_not_kernel
    cmp eax, [begin_kernel_thunk+edi]   ; was the call to a kernel api?
    jl blubb1
    cmp eax, [end_kernel_thunk+edi]
    ja blubb1

; calculate the real api that it should be calling
; using decrypt_key & raw offset of call relative to the section its calling from
    sub eax, [begin_kernel_thunk+edi]
    shr eax, 02
    push edx
    push ecx
    push eax
    mov ecx, [end_kernel_thunk+edi]
    sub ecx, [begin_kernel_thunk+edi]
    shr ecx, 02
    mov eax, ebx
    sub eax, dword ptr [re_temp_offset]
    add eax, [decrypt_key]
    xor edx, edx
    div ecx
    pop eax
    sub eax, edx
    xor edx, edx
    add eax, ecx
    div ecx
    mov eax, edx
    pop ecx
    pop edx
    shl eax, 02
    add eax, [begin_kernel_thunk+edi]
    add eax, [pe_image_base]
    mov dword ptr [ecx], eax
    jmp rfc_scan_next_byte

rfc_not_kernel:

; kernel or user api to be fixed?
    mov edi, 08h
blubb2:
    sub edi, 04h
    cmp edi, -04h
    je rfc_scan_next_byte
    cmp eax, [begin_user_thunk+edi]
    jl blubb2
    cmp eax, [end_user_thunk+edi]
    ja blubb2

; calculate the real api that it should be calling
    sub eax, [begin_user_thunk+edi]
    shr eax, 02
    push edx
    push ecx
    push eax
    mov ecx, [end_user_thunk+edi]
    sub ecx, [begin_user_thunk+edi]
    shr ecx, 02
    mov eax, ebx
    sub eax, dword ptr [re_temp_offset]
    add eax, [decrypt_key]
    xor edx, edx
    div ecx
    pop eax
    sub eax, edx
    xor edx, edx
    add eax, ecx
    div ecx
    mov eax, edx
    pop ecx
    pop edx
    shl eax, 02
    add eax, [begin_user_thunk+edi]
    add eax, [pe_image_base]
    mov dword ptr [ecx], eax
    jmp rfc_scan_next_byte
