; play_my_api_game, brutes / computes tea key #1 from 'encrypted' api pointers

;rdata_buffer    db 50000h dup (?)
;dd_endofbuffer  dd  ?
;asciiz_buffer   db 40h dup (?)
;pmag_temp_key   dd  ?
;dd_user32       dd  ?
;dd_kernel32     dd  ?
;dd_thunks       dd  10 dup (?)
;pmag_api_count  dd  ?
;pmag_api_count2 dd  ?
;pmag_rb_fixup   dd  ?

.code
play_my_api_game:
    pushad
    call    find_first_key      ; algo by moelch to find a decent starting key.
    mov     eax, [key_begin]
    mov     [pmag_temp_key], eax
    call    GetModuleHandleA, offset user32ascii
    mov     [dd_user32], eax    ; get base address of kernel and user dll's
    call    GetModuleHandleA, offset kernel32ascii
    mov     [dd_kernel32], eax
    
pmag_copy_rdata:
    lea     edi, rdata_buffer   ;
    mov     esi, [memory_ptr]   ;
    add     esi, [rdata_offset] ;
    mov     edx, [rdata_size]   ;
    cmp     edx, 100000h        ;
    ja      rdata_error         ;
    shr     edx, 2              ;
crdata_loop:                    ; make a copy of the rdata section from the icd
    mov     eax, [esi]          ;
    mov     [edi], eax          ;
    add     esi, 4              ;
    add     edi, 4              ;
    dec     edx                 ;
    jnz     crdata_loop         ;
    mov     [dd_endofbuffer], edi
    call    pmag_get_thunk_pointers ; get pointers to import thunk arrays
    call    pmag_find_key_one       ; compute (brute) tea key #1
    mov     eax, [pmag_temp_key]    ; pmag_temp_key = tea key #1 = decrypt_key :)
    mov     [decrypt_key], eax
    popad
    ret
    
pmag_find_key_one:
    mov     [pmag_api_count2], 0    ; reset counter
    lea     ebp, dd_thunks          ; pointers to mangled thunks
    mov     esi, [ebp]              ; pointer #1 into esi
    lea     edi, asciiz_buffer      ; where to copy asciiz for decryption
fko_main:
    mov     ebx, [esi]              ; get encrypted asciiz pointer
    xor     ebx, [pmag_temp_key]    ; xor it with tea key #1
    add     ebx, [pmag_rb_fixup]    ; pmag_rb_fixup is the raw offset to rdata, - RVA of rdata
    add     ebx, 2                  ; skip hint
    cmp     ebx, [dd_endofbuffer]   ; check if 'decrypted' pointer falls within our buffer
    ja      fko_badptr              ; if not, inc tea key #1, start again
    cmp     ebx, offset rdata_buffer ;
    jb      fko_badptr              ; etc..
    cmp     dword ptr [ebx], 0      ; check to see if there is any 'encrypted' information here
    jz      fko_badptr              ; or does it point to null's ..
    xor     ecx, ecx
    mov     edx, 10h                ; 10h dwords to copy, 40h bytes
copy_asciiz_data:
    mov     eax, [ebx+ecx]          ; string copy
    mov     [edi+ecx], eax          ; from ebx -> edi
    add     ecx, 4                  ; without increasing either
    dec     edx                     ; so edi will point directly to data to decrypt
    jnz     copy_asciiz_data
    xor     ebx, ebx
    mov     cl, [asciiz_key]        ; asciiz_key is highest byte of tea key #1 xor 0abh
fko_decrypt_asciiz_loop:            ; decrypt the asciiz
    mov     al, byte ptr [edi+ebx]  ; get byte
    mov     ch, al
    xor     al, cl                  ; xor byte
    mov     byte ptr [edi+ebx], al  ; store byte
    jz      asciiz_decrypted        ; if null, job done
    mov     cl, ch
    inc     ebx                     ; inc counter
    cmp     ebx, 40h                ; if 40h, job done
    jnz     fko_decrypt_asciiz_loop
asciiz_decrypted:                   ; test to see if data decrypted to a real asciiz api name
    call    GetProcAddress, [dd_user32], edi
    test    eax,eax
    jnz     fko_good_ascii
    call    GetProcAddress, [dd_kernel32], edi
    test    eax,eax
    jnz     fko_good_ascii
    
fko_badptr:                         ; hmm, bad pointer, start over again
    inc     [pmag_temp_key]         ; inc tea key #1
    mov     [pmag_api_count2], 0    ; reset api counter
    lea     ebp, dd_thunks          ; reset thunk pointer
    mov     esi, [ebp]
    jmp     fko_main

fko_good_ascii:                     ; good pointer! lets try the next :)
    inc     [pmag_api_count2]       ; inc api counter
    add     esi, 4                  ; point esi to next asciiz 'encrypted' pointer
    cmp     dword ptr [esi], 0      ; check for null terminator
    jnz     fko_main                ; jne try next pointer
    
fko_next_thunk:
    add     ebp, 4                  ; else, cycle onto next thunk
    mov     esi, [ebp]
    test    esi, esi                ; check to see if all thunks processed
    jz      fko_exit
    mov     ebx, [pmag_api_count2]  ; check to see if every api pointer has been processed
    cmp     ebx, [pmag_api_count]
    jnz     fko_main
fko_exit:
    ret
    
pmag_get_thunk_pointers:
    pushad
    lea     edi, dd_thunks          ; for storing the address's of each thunk
    lea     ebp, api_pointers       ; missing api pointers from the loader
    lea     ebx, rdata_buffer       ; our clone of the rdata section
    mov     edx, [import_ptr]       ; raw file offset of the image_import_descriptors
    sub     edx, [rdata_offset]     ; sub raw offset of the rdata section
    add     edx, ebx                ; edx -> image_import_descriptors in our buffer
    sub     ebx, [rdata_rva]        ; fix our mem pointer, so when we add rva's from import
    mov     [pmag_rb_fixup], ebx    ;  table, they point into our buffer

pmag_next_iid:
    mov     esi, [edx+12]           ; pointer to lib name
    test    esi, esi
    jz      pmag_gtp_exit           ; null terminator? je exit..
    add     esi, ebx
    cmp     [esi], 'NREK'           ; 'KERN'
    jz      pcorrect_iid
    cmp     [esi], 'RESU'           ; 'USER'
    jz      pcorrect_iid
    cmp     [esi], 'nrek'           ; 'kern'
    jz      pcorrect_iid
    cmp     [esi], 'resu'           ; 'user'
    jz      pcorrect_iid
ptry_next_iid:
    add     edx, 14h
    jmp     pmag_next_iid
    
pcorrect_iid:
    mov     eax, [ebp]              ; load missing pointer into eax..
    add     ebp, 4                  ; point ebp to next missing pointer :)
    mov     esi, [edx]              ; ptr to original_first_thunk
    add     esi, ebx                ; add fixed memptr to it
    cmp     dword ptr [esi], 0      ; first ptr to asciiz
    jnz     ptry_next_iid           ; fucked thunk arrays should begin NULL terminated :D
    mov     [esi], eax              ; stamp missing key into NULL
    mov     [edi], esi              ; save address of thunk in dd_thunks
    add     edi, 4                  ;
    mov     dword ptr [edi], 0      ; hmm, null terminate our data
pmag_count_api:
    inc     [pmag_api_count]
    mov     ecx, [esi+4]            ; load next api pointer into ecx
    add     esi, 4                  ;
    test    ecx,ecx                 ; is it the NULL terminator?
    jnz     pmag_count_api          ; yes, loop and count
    jmp     ptry_next_iid           ; else, find the next thunk to play with

pmag_gtp_exit:
    popad                           ; yeah!
    ret
